/*
 File    : SonarPropertyGenerator.cls
 Module  : rtb/util
 Author  : jeff
 Created : 12/27/22
 About   : Initially created under Task 4649.
 Purpose :
*/
USING Progress.Lang.*.
ROUTINE-LEVEL ON ERROR UNDO, THROW.

CLASS rtb.util.SonarProperties: 

  DEFINE PUBLIC PROPERTY sonar-projectKey                AS CHARACTER INITIAL ""           GET. SET.  
  DEFINE PUBLIC PROPERTY sonar-projectName               AS CHARACTER INITIAL ""           GET. SET.
  DEFINE PUBLIC PROPERTY sonar-projectVersion            AS CHARACTER INITIAL ""           GET. SET.
  DEFINE PUBLIC PROPERTY sonar-projectDescription        AS CHARACTER INITIAL ""           GET. SET.
  DEFINE PUBLIC PROPERTY sonar-sources                   AS CHARACTER INITIAL ""           GET. SET.
  DEFINE PUBLIC PROPERTY sonar-exclusions                AS CHARACTER INITIAL "**/list/**" GET. SET.
  DEFINE PUBLIC PROPERTY sonar-sourceEncoding            AS CHARACTER INITIAL ""           GET. SET.
  DEFINE PUBLIC PROPERTY sonar-oe-binaries               AS CHARACTER INITIAL ""           GET. SET.
  DEFINE PUBLIC PROPERTY sonar-oe-propath                AS CHARACTER INITIAL ""           GET. SET.
  DEFINE PUBLIC PROPERTY sonar-oe-dlc                    AS CHARACTER INITIAL ""           GET. SET.
  DEFINE PUBLIC PROPERTY sonar-oe-propath-dlc            AS LOGICAL   INITIAL TRUE         GET. SET.
  DEFINE PUBLIC PROPERTY sonar-oe-databases              AS CHARACTER INITIAL ""           GET. SET.
  DEFINE PUBLIC PROPERTY sonar-oe-aliases                AS CHARACTER INITIAL ""           GET. SET.
  DEFINE PUBLIC PROPERTY sonar-cpd-exclusions            AS CHARACTER INITIAL "dump/**"    GET. SET.
  DEFINE PUBLIC PROPERTY sonar-oe-cpd-debug              AS LOGICAL   INITIAL FALSE        GET. SET.
  DEFINE PUBLIC PROPERTY sonar-oe-proparse-debug         AS LOGICAL   INITIAL FALSE        GET. SET.
  DEFINE PUBLIC PROPERTY sonar-oe-file-suffixes          AS CHARACTER INITIAL ""           GET. SET.
  DEFINE PUBLIC PROPERTY sonar-oe-coverage-profiler-dirs AS CHARACTER INITIAL ""           GET. SET.
  DEFINE PUBLIC PROPERTY sonar-oe-analytics              AS LOGICAL   INITIAL FALSE        GET. SET.
  DEFINE PUBLIC PROPERTY sonar-login                     AS CHARACTER INITIAL ""           GET. SET.
  DEFINE PUBLIC PROPERTY sonar-oe-rtb                    AS LOGICAL   INITIAL TRUE         GET. SET.

  CONSTRUCTOR PUBLIC SonarProperties ():
    SUPER().  
  END CONSTRUCTOR.
    
  DESTRUCTOR PUBLIC SonarProperties ():
  END DESTRUCTOR.
  
  METHOD PUBLIC VOID writeFile (pcPathname AS CHARACTER):
    
    OUTPUT TO VALUE(pcPathname).
    
    PUT UNFORMATTED "sonar.projectKey=" sonar-projectKey SKIP.
    PUT UNFORMATTED "sonar.projectName=" sonar-projectName SKIP.
    PUT UNFORMATTED "sonar.projectVersion=" sonar-projectVersion SKIP.
    PUT UNFORMATTED "sonar.projectDescription=" sonar-projectDescription SKIP.
    PUT UNFORMATTED "sonar.sources=" sonar-sources SKIP.
    PUT UNFORMATTED "sonar.exclusions=" sonar-exclusions SKIP.
    PUT UNFORMATTED "sonar.sourceEncoding=" sonar-sourceEncoding SKIP.
    PUT UNFORMATTED "sonar.oe.binaries=" sonar-oe-binaries SKIP.
    PUT UNFORMATTED "sonar.oe.propath=" sonar-oe-propath SKIP.
    PUT UNFORMATTED "sonar.oe.dlc=" sonar-oe-dlc SKIP.
    PUT UNFORMATTED "sonar.oe.propath.dlc=" STRING(sonar-oe-propath-dlc, "true/false") SKIP.
    PUT UNFORMATTED "sonar.oe.databases=" sonar-oe-databases SKIP.
    PUT UNFORMATTED "sonar.oe.aliases=" sonar-oe-aliases SKIP.
    PUT UNFORMATTED "sonar.cpd.exclusions=" sonar-cpd-exclusions SKIP.
    PUT UNFORMATTED "sonar.cpd.debug=" STRING(sonar-oe-cpd-debug, "true/false") SKIP.
    PUT UNFORMATTED "sonar.oe.proparse.debug=" STRING(sonar-oe-proparse-debug, "true/false") SKIP.
    
    IF sonar-oe-file-suffixes <> "" THEN 
      PUT UNFORMATTED "sonar.oe.file.suffixes=" sonar-oe-file-suffixes SKIP.
    
    IF sonar-oe-coverage-profiler-dirs <> "" THEN   
      PUT UNFORMATTED "sonar.oe.coverage.profiler.dirs=" sonar-oe-coverage-profiler-dirs SKIP.
      
    PUT UNFORMATTED "sonar.oe.analytics=" STRING(sonar-oe-analytics, "true/false") SKIP.
    PUT UNFORMATTED "sonar.login=" sonar-login SKIP.
    PUT UNFORMATTED "sonar.oe.rtb=" STRING(sonar-oe-rtb, "true/false") SKIP.   
    
    OUTPUT CLOSE.  
    
  END METHOD.

END CLASS.
